﻿import re
import urlparse
import datetime
import json
import time

import xbmcaddon
import xbmcgui
import xbmcplugin
import xbmc

import livelib
import boogietools as bt

bt.initdirs("plugin.video.taraftarium")

domain="http://www.taraftarium24tv.com"
encoding="utf-8"
c=xbmc.getLocalizedString(19029)
handle,page,args=bt.link_from()
ll=livelib.livelib()
lang=xbmc.getLanguage(xbmc.ISO_639_1).lower()
notifications={"red":"[COLOR red]%s[/COLOR]",
 		    "orange":"[COLOR orange]%s[/COLOR]",
			 "green":"[COLOR green]%s[/COLOR]",
			}

def scrape_chans():
	chs=[int(x) for x in set(re.findall('<a target="stream" href="ch/ch([0-9]*?)\.html">',bt.get_page(domain,encoding)))]
	return sorted(chs)

def scrape_events(chs):
	chans={}
	for ch in chs:
		chans[ch]="%s %d"%(c,ch)
	page=bt.get_page("%s/ch/schedule.html"%domain,encoding,referer=domain)
	divs=re.findall('<span class="mactext">(.*?)<a class="mac"',page,re.DOTALL)
	for div in divs:
		text=re.findall('<font color=".*?">(.*?)</font>',div)
		if len(text):
			subchs=re.findall('class="link">Channel ([0-9]*?)</a>',div)
			for subch in subchs:
				chans[int(subch)]=text[0]
	return chans



if page=="root":
	events=scrape_events(scrape_chans())
	for eventid,event in events.iteritems():
		li=xbmcgui.ListItem("%s %d : %s" % (c,eventid,event), iconImage="DefaultFolder.png", thumbnailImage="DefaultFolder.png")
		u=bt.link_to("event",{"eventid":eventid,"eventname":event})
		xbmcplugin.addDirectoryItem(handle,u,li,False)
	
	xbmcplugin.endOfDirectory(handle)

if page=="event":
#	print "%s/ch/ch%d.html"%(domain,args["eventid"])
	purl="%s/ch/ch%d.html"%(domain,args["eventid"])
	page=bt.get_page(purl,encoding,referer=domain)
	iframes=[]
	pDialog = xbmcgui.DialogProgress()
	pDialog.create('Opening Stream', "Conencting to %s ..."%(args["eventname"]))
	iframes.append('src="(.*?soccerjumbotv.me.*?)"')
	for iframe in iframes:
		ipage=re.findall(iframe,page)
		if len(ipage):
			page=bt.get_page(ipage[0],encoding,referer=purl)
			purl=ipage[0]
	print purl
	p3g=re.findall("channel='(.*?)'.*?src='http://p3g.tv/resources/scripts/p3g.js'",page)
	fidscript=re.findall('fid="(.*?)".*?script.*?src="(.*?)"',page)
	aliez=re.findall('src="(.*?aliez\..*?/player/live\.php.*?)"',page)
	mips=re.findall("channel='(.*?)', .='(.*?)';</script><script type='text/javascript' src='(.*?)'></script>",page)
	playerhd=re.findall("http://(.*?)/.*php\?file=([0-9]*?)&",page)
	weplayer=re.findall("id='(.*?)'; width='([0-9]*?)'; height='([0-9]*?)';</script><script type='text/javascript' src='/player.js'>",page)
	weplayer2=re.findall("id='(.*?)'; width='([0-9]*?)'; height='([0-9]*?)';</script><script type='text/javascript' src='http\://weplayer.pw/player.js'>",page)
	jw=re.findall('content.jwplatform.com/players/(.*?)\.html"',page)
	worldspor=re.findall('fid="(.*?)"',page)
	micast=re.findall('src="(.*?/iframe.php\?ch=.*?)"',page)
	sostart=re.findall("id='(.*?)';.*?</script><script type=.text/javascript. src=.http://sostart.org/player",page)
	zony=re.findall("channel='(.*?)'.*?src='.*?/static/scripts/zony\.js'",page)
	castamp=re.findall('channel="(.*?)".*?src=".*?castamp.com/embed\.js"',page)
	zenex=re.findall("channel='(.*?)'.*?src='.*?data/scripts/ZenexEmbed\.js'",page)
	janjua=re.findall("channel='(.*?)'.*?src='.*?/scripts/janjua.js'",page)
	ll.timeout=30
	if len(p3g):
		type,stream=ll.scrape_url("p3g",p3g[0],purl)
	elif len(janjua):
		type,stream=ll.scrape_url("janjua",janjua[0],purl)
	elif len(zenex):
		type,stream=ll.scrape_url("zenex",zenex[0],purl)
	elif len(castamp):
		type,stream=ll.scrape_url("castamp",castamp[0],purl)
	elif len(zony):
		type,stream=ll.scrape_url("zony",zony[0],purl)
	elif len(fidscript) and "cast4u" in fidscript[0][1]:
		key,u=fidscript[0]
		type,stream=ll.scrape_url("cast4u",key,domain)
	elif len(fidscript) and "hdcast" in fidscript[0][1]:
		key,u=fidscript[0]
		type,stream=ll.scrape_url("hdcast",key,domain)
	elif len(aliez)>0:
		#id=urlparse.parse_qs(urlparse.urlparse(aliez[0]).query)["id"][0]
		type,stream=ll.scrape_url("aliez",aliez[0],domain)
	elif len(jw)>0:
		type,stream=ll.scrape_url("jw",jw[0],domain)
	elif len(worldspor)>0:
		type,stream=ll.scrape_url("worldspor",worldspor[0],domain)
	elif len(micast):
		type,stream=ll.scrape_url("micast",micast[0],purl)
	elif len(mips)>0:
		channel=mips[0][0]
		e=mips[0][1]
		script=mips[0][2]
		type,stream=ll.scrape_url("mips",channel,e,script,domain)
	elif len(weplayer)>0:
		id,w,h=weplayer[0]
		type,stream=ll.scrape_url("weplayer",id,domain,w,h)
	elif len(weplayer2)>0:
		id,w,h=weplayer2[0]
		type,stream=ll.scrape_url("weplayer",id,domain,w,h)
	elif len(playerhd)>0:
		domain,id=playerhd[0]
		type,stream=ll.scrape_url("playerhd",domain,id,purl)
	elif len(sostart)>0:
		type,stream=ll.scrape_url("sostart",sostart[0],purl)
	else:
		type="ERROR: Can't detect streaming service type"
		stream = ""

	pDialog.close()
	if "ERROR:" in type:
		dialog = xbmcgui.Dialog()
		dialog.ok('ERROR', type)
	else:
		li=xbmcgui.ListItem(args["eventname"],iconImage="DefaultFolder.png", thumbnailImage="DefaultFolder.png")
		xbmc.Player().play(stream,li)
